Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.trolltech.qt.gui
Class QGraphicsLinearLayout

    java.lang.Object
      com.trolltech.qt.internal.QSignalEmitterInternal
          com.trolltech.qt.QSignalEmitter
              com.trolltech.qt.QtJambiObject
                  com.trolltech.qt.gui.QGraphicsLayout
                      com.trolltech.qt.gui.QGraphicsLinearLayout

All Implemented Interfaces:
  QGraphicsLayoutItemInterface, QtJambiInterface

    public class QGraphicsLinearLayout

extends QGraphicsLayout

The `QGraphicsLinearLayout` class provides a horizontal or vertical layout for managing widgets in Graphics View. The default orientation for a linear layout is `Qt::Horizontal` . You can choose a vertical orientation either by calling `setOrientation()`, or by passing `Qt::Vertical` to `QGraphicsLinearLayout`'s constructor.

The most common way to use `QGraphicsLinearLayout` is to construct an object on the heap with no parent, add widgets and layouts by calling `addItem()`, and finally assign the layout to a widget by calling `QGraphicsWidget::setLayout()`.

            QGraphicsScene scene = new QGraphicsScene();
            QGraphicsWidget textEdit = scene.addWidget(new QTextEdit());
            QGraphicsWidget pushButton = scene.addWidget(new QPushButton());

            QGraphicsLinearLayout layout = new QGraphicsLinearLayout();
            layout.addItem(textEdit);
            layout.addItem(pushButton);

            QGraphicsWidget form = new QGraphicsWidget();
            form.setLayout(layout);
            scene.addItem(form);

You can add widgets, layouts, stretches (`addStretch()`, `insertStretch()` or `setStretchFactor()`), and gaps (addGap() and `setItemSpacing()`) to a linear layout. The layout takes ownership of the items, with one natural exception: when a layout is assigned to a widget, all widgets inside the layout are automatically reparented to the widget, effectively signing over ownership from the layout to the layout-managed widget. You can access each item in the layout by calling `count()` and `itemAt()`. Calling `removeAt()` or `removeItem()` will remove an item from the layout, without destroying it.

## Size Hints and Size Policies in QGraphicsLinearLayout

`QGraphicsLinearLayout` respects each item's size hints and size policies, and when the layout contains more space than the items can fill, each item is arranged according to the layout's alignment for that item. You can set an alignment for each item by calling `setAlignment()`, and check the alignment for any item by calling `alignment()`. By default, items are centered both vertically and horizontally.

## Spacing within QGraphicsLinearLayout

Between the items, the layout distributes some space. The actual amount of space depends on the managed widget's current style, but the common spacing is 4. You can also set your own spacing by calling `setSpacing()`, and get the current spacing value by calling `spacing()`. If you want to configure individual spacing for your items, you can call `setItemSpacing()`.

## Stretch Factor in QGraphicsLinearLayout

You can assign a stretch factor to each item to control how much space it will get compared to the other items. By default, two identical widgets arranged in a linear layout will have the same size, but if the first widget has a stretch factor of 1 and the second widget has a stretch factor of 2, the first widget will get 1/3 of the available space, and the second will get 2/3.

`QGraphicsLinearLayout` calculates the distribution of sizes by adding up the stretch factors of all items, and then dividing the available space accordingly. The default stretch factor is 0 for all items; a factor of 0 means the item does not have any defined stretch factor; effectively this is the same as setting the stretch factor to 1. The stretch factor only applies to the available space in the lengthwise direction of the layout (following its orientation). If you want to control both the item's horizontal and vertical stretch, you can use `QGraphicsGridLayout` instead.

## QGraphicsLinearLayout Compared to Other Layouts

`QGraphicsLinearLayout` is very similar to `QVBoxLayout` and `QHBoxLayout`, but in contrast to these classes, it is used to manage `QGraphicsWidget` and `QGraphicsLayout` instead of `QWidget` and `QLayout`.

See also:
  `QGraphicsGridLayout`, and `QGraphicsWidget`.

Nested Class Summary

Nested classes/interfaces inherited from class com.trolltech.qt.QSignalEmitter
`QSignalEmitter.AbstractSignal, QSignalEmitter.Signal0, QSignalEmitter.Signal1, QSignalEmitter.Signal2, QSignalEmitter.Signal3, QSignalEmitter.Signal4, QSignalEmitter.Signal5, QSignalEmitter.Signal6, QSignalEmitter.Signal7, QSignalEmitter.Signal8, QSignalEmitter.Signal9`

Nested classes/interfaces inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`com.trolltech.qt.internal.QSignalEmitterInternal.AbstractSignalInternal`

Field Summary

Fields inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`currentSender`

Constructor Summary
`QGraphicsLinearLayout()` Constructs a `QGraphicsLinearLayout` instance using `Qt::Horizontal` orientation.
`QGraphicsLinearLayout(QGraphicsLayoutItemInterface parent)` Constructs a `QGraphicsLinearLayout` instance using `Qt::Horizontal` orientation.
`QGraphicsLinearLayout(Qt.Orientation orientation)` Constructs a `QGraphicsLinearLayout` instance.
`QGraphicsLinearLayout(Qt.Orientation orientation, QGraphicsLayoutItemInterface parent)` Constructs a `QGraphicsLinearLayout` instance.

Method Summary
`void` | `addItem(QGraphicsLayoutItemInterface item)` This convenience function is equivalent to calling insertItem(-1, `item`).
`void` | `addStretch()` This convenience function is equivalent to calling insertStretch(-1, `stretch`).
`void` | `addStretch(int stretch)` This convenience function is equivalent to calling insertStretch(-1, `stretch`).
`Qt.Alignment` | `alignment(QGraphicsLayoutItemInterface item)` Returns the alignment for `item`.
`void` | `insertItem(int index, QGraphicsLayoutItemInterface item)` Inserts `item` into the layout at `index`, or before any item that is currently at `index`.
`void` | `insertStretch(int index)` Inserts a stretch of `stretch` at `index`, or before any item that is currently at `index`.
`void` | `insertStretch(int index, int stretch)` Inserts a stretch of `stretch` at `index`, or before any item that is currently at `index`.
`double` | `itemSpacing(int index)` Returns the spacing after item at `index`.
`Qt.Orientation` | `orientation()` This property holds the orientation of the linear layout.
`void` | `removeItem(QGraphicsLayoutItemInterface item)` Removes `item` from the layout without destroying it.
`void` | `setAlignment(QGraphicsLayoutItemInterface item, Qt.Alignment alignment)` Sets the alignment of `item` to `alignment`.
`void` | `setAlignment(QGraphicsLayoutItemInterface item, Qt.AlignmentFlag[] alignment)` Sets the alignment of `item` to `alignment`.
`void` | `setItemSpacing(int index, double spacing)` Sets the spacing after item at `index` to `spacing`.
`void` | `setOrientation(Qt.Orientation orientation)` This property holds the orientation of the linear layout.
`void` | `setSpacing(double spacing)` This property holds the layout's default spacing.
`void` | `setStretchFactor(QGraphicsLayoutItemInterface item, int stretch)` Sets the stretch factor for `item` to `stretch`.
`double` | `spacing()` This property holds the layout's default spacing.
`int` | `stretchFactor(QGraphicsLayoutItemInterface item)` Returns the stretch factor for `item`.

Methods inherited from class com.trolltech.qt.gui.QGraphicsLayout
`activate, contentsRect, count, effectiveSizeHint, geometry, getContentsMargins, invalidate, isActivated, isLayout, itemAt, maximumHeight, maximumSize, maximumWidth, minimumHeight, minimumSize, minimumWidth, parentLayoutItem, preferredHeight, preferredSize, preferredWidth, removeAt, setContentsMargins, setGeometry, setMaximumHeight, setMaximumSize, setMaximumSize, setMaximumWidth, setMinimumHeight, setMinimumSize, setMinimumSize, setMinimumWidth, setParentLayoutItem, setPreferredHeight, setPreferredSize, setPreferredSize, setPreferredWidth, setSizePolicy, setSizePolicy, sizeHint, sizePolicy, updateGeometry, widgetEvent`

Methods inherited from class com.trolltech.qt.QtJambiObject
`dispose, disposed, equals, finalize, reassignNativeResources, tr, tr, tr`

Methods inherited from class com.trolltech.qt.QSignalEmitter
`blockSignals, disconnect, disconnect, signalsBlocked, signalSender, thread`

Methods inherited from class com.trolltech.qt.internal.QSignalEmitterInternal
`__qt_signalInitialization`

Methods inherited from class java.lang.Object
`clone, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Methods inherited from interface com.trolltech.qt.QtJambiInterface
`disableGarbageCollection, nativeId, nativePointer, reenableGarbageCollection, setJavaOwnership`

Constructor Detail

### QGraphicsLinearLayout

    public QGraphicsLinearLayout()

  Constructs a `QGraphicsLinearLayout` instance using `Qt::Horizontal` orientation. `parent` is passed to `QGraphicsLayout`'s constructor.

### QGraphicsLinearLayout

    public QGraphicsLinearLayout(QGraphicsLayoutItemInterface parent)

  Constructs a `QGraphicsLinearLayout` instance using `Qt::Horizontal` orientation. `parent` is passed to `QGraphicsLayout`'s constructor.

### QGraphicsLinearLayout

    public QGraphicsLinearLayout(Qt.Orientation orientation)

  Constructs a `QGraphicsLinearLayout` instance. You can pass the `orientation` for the layout, either horizontal or vertical, and `parent` is passed to `QGraphicsLayout`'s constructor.

### QGraphicsLinearLayout

    public QGraphicsLinearLayout(Qt.Orientation orientation,
                                 QGraphicsLayoutItemInterface parent)

  Constructs a `QGraphicsLinearLayout` instance. You can pass the `orientation` for the layout, either horizontal or vertical, and `parent` is passed to `QGraphicsLayout`'s constructor.

Method Detail

### addItem

    public final void addItem(QGraphicsLayoutItemInterface item)

  This convenience function is equivalent to calling insertItem(-1, `item`).

### addStretch

    public final void addStretch()

  This convenience function is equivalent to calling insertStretch(-1, `stretch`).

### addStretch

    public final void addStretch(int stretch)

  This convenience function is equivalent to calling insertStretch(-1, `stretch`).

### alignment

    public final Qt.Alignment alignment(QGraphicsLayoutItemInterface item)

  Returns the alignment for `item`. The default alignment is `Qt::AlignCenter` .

  The alignment decides how the item is positioned within its assigned space in the case where there's more space available in the layout than the widgets can occupy.

See also:
  `setAlignment()`.

### insertItem

    public final void insertItem(int index,
                                 QGraphicsLayoutItemInterface item)

  Inserts `item` into the layout at `index`, or before any item that is currently at `index`.

See also:
  `addItem()`, `itemAt()`, `insertStretch()`, and `setItemSpacing()`.

### insertStretch

    public final void insertStretch(int index)

  Inserts a stretch of `stretch` at `index`, or before any item that is currently at `index`.

See also:
  `addStretch()`, `setStretchFactor()`, `setItemSpacing()`, and `insertItem()`.

### insertStretch

    public final void insertStretch(int index,
                                    int stretch)

  Inserts a stretch of `stretch` at `index`, or before any item that is currently at `index`.

See also:
  `addStretch()`, `setStretchFactor()`, `setItemSpacing()`, and `insertItem()`.

### itemSpacing

    public final double itemSpacing(int index)

  Returns the spacing after item at `index`.

See also:
  `setItemSpacing()`.

### orientation

    public final Qt.Orientation orientation()

  This property holds the orientation of the linear layout. This property toggles the layout orientation. Changing the layout orientation will automatically invalidate the layout.

See also:
  `invalidate()`.

### removeItem

    public final void removeItem(QGraphicsLayoutItemInterface item)

  Removes `item` from the layout without destroying it. Ownership of `item` is transferred to the caller.

See also:
  `removeAt()`, and `insertItem()`.

### setAlignment

    public final void setAlignment(QGraphicsLayoutItemInterface item,
                                   Qt.AlignmentFlag[] alignment)

  Sets the alignment of `item` to `alignment`. If `item`'s alignment changes, the layout is automatically invalidated.

See also:
  `alignment()`, and `invalidate()`.

### setAlignment

    public final void setAlignment(QGraphicsLayoutItemInterface item,
                                   Qt.Alignment alignment)

  Sets the alignment of `item` to `alignment`. If `item`'s alignment changes, the layout is automatically invalidated.

See also:
  `alignment()`, and `invalidate()`.

### setItemSpacing

    public final void setItemSpacing(int index,
                                     double spacing)

  Sets the spacing after item at `index` to `spacing`.

See also:
  `itemSpacing()`.

### setOrientation

    public final void setOrientation(Qt.Orientation orientation)

  This property holds the orientation of the linear layout. This property toggles the layout orientation. Changing the layout orientation will automatically invalidate the layout.

See also:
  `invalidate()`.

### setSpacing

    public final void setSpacing(double spacing)

  This property holds the layout's default spacing. This property adjusts the layout's default spacing. The spacing applies to the vertical and horizontal distance between items.

See also:
  `setItemSpacing()`, `setStretchFactor()`, and `QGraphicsGridLayout::setSpacing()`.

### setStretchFactor

    public final void setStretchFactor(QGraphicsLayoutItemInterface item,
                                       int stretch)

  Sets the stretch factor for `item` to `stretch`. If an item's stretch factor changes, this function will invalidate the layout.

  Setting `stretch` to 0 removes the stretch factor from the item, and is effectively equivalent to setting `stretch` to 1.

See also:
  `stretchFactor()`.

### spacing

    public final double spacing()

  This property holds the layout's default spacing. This property adjusts the layout's default spacing. The spacing applies to the vertical and horizontal distance between items.

See also:
  `setItemSpacing()`, `setStretchFactor()`, and `QGraphicsGridLayout::setSpacing()`.

### stretchFactor

    public final int stretchFactor(QGraphicsLayoutItemInterface item)

  Returns the stretch factor for `item`. The default stretch factor is 0, meaning that the item has no assigned stretch factor.

See also:
  `setStretchFactor()`.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD